import { Injectable } from '@nestjs/common';
import { BaseReportService } from '../shared/services/base-report.service';
import { GetReportConfigDto } from '../shared/dto/report-config.get.dto';
import { GetReportDataDto } from '../shared/dto/report-data.get.dto';
import { ReportConfigs } from '../shared/configs';

@Injectable()
export class ReportService extends BaseReportService {
  async getReportConfig(query: GetReportConfigDto) {
    const { unique_names = [], group_names = [] } = query;

    let configs = ReportConfigs;
    if (group_names.length > 0) {
      configs = configs.filter((item) => group_names.includes(item.group_name));
    }

    if (unique_names.length > 0) {
      configs = configs.filter((item) =>
        unique_names.includes(item.unique_name),
      );
    }

    return configs;
  }

  async getReportData(body: GetReportDataDto) {
    return 'you hit API for get report data';
  }

  async getReportMeta(body: GetReportDataDto) {
    return 'you hit API for get report meta';
  }
}
